Imports System
Imports System.Linq
Imports System.Windows
Imports System.Windows.Controls
Imports ESRI.ArcGIS.Client
Imports ESRI.ArcGIS.Client.Geometry

	Partial Public Class ToolkitAttachmentEditor
		Inherits UserControl
		Private Shared _mercator As New ESRI.ArcGIS.Client.Projection.WebMercator()
		Private featureLayer As FeatureLayer
		Public Sub New()
			InitializeComponent()

			Dim initialExtent As New ESRI.ArcGIS.Client.Geometry.Envelope(TryCast(_mercator.FromGeographic(New ESRI.ArcGIS.Client.Geometry.MapPoint(-122.4306073721, 37.7666097907)), MapPoint), TryCast(_mercator.FromGeographic(New ESRI.ArcGIS.Client.Geometry.MapPoint(-122.4230971868, 37.77197420877)), MapPoint))

			initialExtent.SpatialReference = New SpatialReference(102100)

			MyMap.Extent = initialExtent
		End Sub

		Private Sub FeatureLayer_MouseLeftButtonUp(ByVal sender As Object, ByVal e As GraphicMouseButtonEventArgs)

			For x As Integer = 0 To featureLayer.SelectionCount - 1
				featureLayer.SelectedGraphics.ToList()(x).UnSelect()
			Next x

			e.Graphic.Select()
			MyAttachmentEditor.GraphicSource = e.Graphic
		End Sub

		Private Sub MyAttachmentEditor_UploadFailed(ByVal sender As Object, ByVal e As ESRI.ArcGIS.Client.Toolkit.AttachmentEditor.UploadFailedEventArgs)
			MessageBox.Show(e.Result.Message)
		End Sub

		Private Sub MyMap_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
			featureLayer = TryCast(MyMap.Layers(1), FeatureLayer)
			MyAttachmentEditor.FeatureLayer = featureLayer
		End Sub
	End Class

