Imports Microsoft.VisualBasic
Imports System.Windows
Imports System.Windows.Controls
Imports ESRI.ArcGIS.Client
Imports ESRI.ArcGIS.Client.Tasks


	Partial Public Class Routing
		Inherits UserControl
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub MyMap_MouseClick(ByVal sender As Object, ByVal e As ESRI.ArcGIS.Client.Map.MouseEventArgs)
			Dim stopsGraphicsLayer As GraphicsLayer = TryCast(MyMap.Layers("MyStopsGraphicsLayer"), GraphicsLayer)
			Dim [stop] As New Graphic() With {.Geometry = e.MapPoint, .Symbol = TryCast(LayoutRoot.Resources("StopSymbol"), ESRI.ArcGIS.Client.Symbols.Symbol)}
			stopsGraphicsLayer.Graphics.Add([stop])

			If stopsGraphicsLayer.Graphics.Count > 1 Then
				Dim routeTask As RouteTask = TryCast(LayoutRoot.Resources("MyRouteTask"), RouteTask)
				If routeTask.IsBusy Then
					routeTask.CancelAsync()
					stopsGraphicsLayer.Graphics.RemoveAt(stopsGraphicsLayer.Graphics.Count - 1)
				End If
			routeTask.SolveAsync(New RouteParameters() With {.Stops = stopsGraphicsLayer, .UseTimeWindows = False, .OutSpatialReference = MyMap.SpatialReference})
			End If
		End Sub

		Private Sub MyRouteTask_Failed(ByVal sender As Object, ByVal e As TaskFailedEventArgs)
			Dim errorMessage As String = "Routing error: "
			errorMessage &= e.Error.Message
			For Each detail As String In (TryCast(e.Error, ServiceException)).Details
				errorMessage &= "," & detail
			Next detail

			MessageBox.Show(errorMessage)
			Dim stopsGraphicsLayer As GraphicsLayer = TryCast(MyMap.Layers("MyStopsGraphicsLayer"), GraphicsLayer)
			stopsGraphicsLayer.Graphics.RemoveAt(stopsGraphicsLayer.Graphics.Count - 1)
		End Sub

		Private Sub MyRouteTask_SolveCompleted(ByVal sender As Object, ByVal e As RouteEventArgs)
			Dim routeGraphicsLayer As GraphicsLayer = TryCast(MyMap.Layers("MyRouteGraphicsLayer"), GraphicsLayer)
			routeGraphicsLayer.Graphics.Clear()

			Dim routeResult As RouteResult = e.RouteResults(0)
			routeResult.Route.Symbol = TryCast(LayoutRoot.Resources("RouteSymbol"), ESRI.ArcGIS.Client.Symbols.Symbol)

			Dim lastRoute As Graphic = routeResult.Route

			Dim totalTime As Decimal = CDec(lastRoute.Attributes("Total_Time"))
			Dim tip As String = String.Format("{0} minutes", totalTime.ToString("#0.000"))
			lastRoute.Attributes.Add("TIP", tip)

			routeGraphicsLayer.Graphics.Add(lastRoute)
		End Sub
	End Class

