﻿Imports System
Imports System.Net
Imports System.Windows.Controls
Imports ESRI.ArcGIS.Client.Geometry
Imports System.Collections.Generic
Imports System.IO
Imports System.Web.Script.Serialization


	''' <summary>
	''' Interaction logic for SOEElevationJSSerializer.xaml
	''' </summary>
	Partial Public Class SOEElevationJSSerializer
		Inherits UserControl
		Private Shared _mercator As New ESRI.ArcGIS.Client.Projection.WebMercator()

		Private serializer As JavaScriptSerializer

		Public Sub New()
			InitializeComponent()
			serializer = New JavaScriptSerializer()
		End Sub
		Private Sub MyMap_MouseClick(ByVal sender As Object, ByVal e As ESRI.ArcGIS.Client.Map.MouseEventArgs)
			Dim geographicPoint As MapPoint = TryCast(_mercator.ToGeographic(e.MapPoint), MapPoint)

			Dim SOEurl As String = "http://sampleserver4.arcgisonline.com/ArcGIS/rest/services/Elevation/ESRI_Elevation_World/MapServer/exts/ElevationsSOE/ElevationLayers/1/GetElevationAtLonLat"
			SOEurl &= String.Format(System.Globalization.CultureInfo.InvariantCulture, "?lon={0}&lat={1}&f=json", geographicPoint.X, geographicPoint.Y)

			Dim webClient As New WebClient()

			AddHandler webClient.OpenReadCompleted, AddressOf wc_OpenReadCompleted

			webClient.OpenReadAsync(New Uri(SOEurl))
			MyInfoWindow.Anchor = e.MapPoint
	
		End Sub
		Private Sub wc_OpenReadCompleted(ByVal sender As Object, ByVal e As OpenReadCompletedEventArgs)
			If e.Error IsNot Nothing Then
				Return
			End If
			Dim reader As New StreamReader(e.Result)
			Dim responseString As String = reader.ReadToEnd()
			Dim results As IDictionary(Of String, Object) = TryCast(serializer.DeserializeObject(responseString), IDictionary(Of String, Object))

			If results IsNot Nothing AndAlso results.ContainsKey("elevation") Then
				Dim elevation As Double = Math.Round(Convert.ToDouble(results("elevation")), 0)
				e.Result.Close()
				MyInfoWindow.Content = String.Format("Elevation: {0} meters", elevation.ToString())
				MyInfoWindow.IsOpen = True
			Else
				MyInfoWindow.IsOpen = False
			End If
		End Sub
	End Class

