﻿Imports System.Windows.Controls
Imports ESRI.ArcGIS.Client.WebMap
Imports System.Net
Imports System
Imports System.Web.Script.Serialization
Imports System.IO
Imports System.Collections.Generic
Imports System.Windows

''' <summary>
''' Interaction logic for LoadSecureWebMap.xaml
''' </summary>
Partial Public Class LoadSecureWebMap
	Inherits UserControl
	Private serializer As JavaScriptSerializer

	Public Sub New()
		InitializeComponent()
		serializer = New JavaScriptSerializer()
	End Sub
	Private Sub LoadWebMapButton_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs)
		Dim webClient As New WebClient()

		Dim arcgisComTokenUrl As String = "https://www.arcgis.com/sharing/generateToken"
		arcgisComTokenUrl &= String.Format("?username={0}&password={1}&expiration={2}&TickCount={3}&client=requestip&f=json", UsernameTextBox.Text, PasswordTextBox.Password, 30, Environment.TickCount)

		AddHandler webClient.OpenReadCompleted, AddressOf wc_OpenReadCompleted

		webClient.OpenReadAsync(New Uri(arcgisComTokenUrl))
	End Sub
	Private Sub wc_OpenReadCompleted(ByVal s As Object, ByVal a As OpenReadCompletedEventArgs)
		Dim webMap As New Document()
		Dim reader As New StreamReader(a.Result)
		Dim responseString As String = reader.ReadToEnd()
		Dim results As IDictionary(Of String, Object) = TryCast(serializer.DeserializeObject(responseString), IDictionary(Of String, Object))
		a.Result.Close()
		Dim token As String = Nothing
		If results.ContainsKey("token") Then
			token = results("token").ToString()
		End If
		a.Result.Close()
		webMap.Token = token
		AddHandler webMap.GetMapCompleted, AddressOf webMap_GetMapCompleted
		webMap.GetMapAsync(WebMapTextBox.Text)
	End Sub

	Private Sub webMap_GetMapCompleted(ByVal sender As Object, ByVal e As GetMapCompletedEventArgs)
		If Not e.Error Is Nothing Then
			MessageBox.Show(String.Format("Unable to load webmap. {0}", e.Error.Message))
		Else
			LayoutRoot.Children.Insert(0, e.Map)
		End If
	End Sub
End Class
